/**
  *  \file client/screens/histscreen.h
  *  \brief Ship History Screen (F6)
  *
  *  (c) 2001-2021 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_SCREENS_HISTSCREEN_H
#define PCC_V2_CLIENT_SCREENS_HISTSCREEN_H

#include "cpluslib/sigslot.h"
#include "game/coord.h"
#include "game/objsel.h"

/** Object selection that also tracks a turn number. History screen
    elements can use this to track the turn list selection.

    The turn is set by the WHistoryShipPositionTile, and queried by
    whoever needs it. */
class WHistoryObjectSelection : public GProxyObjectSelection {
    int turn;
 public:
    WHistoryObjectSelection(GObjectSelection& base);

    void setTurn(int turn);
    int getTurn() const;
    void browse(bool backward, bool marked_only);

    GPoint getPos();

    Signal0 sig_turn_changed;
};

void doHistoryScreen();

#endif
